{$A+,B-,E-,F-,N-,O-,V- }

{$IFDEF DEBUG }
  {$D+,I+,L+,R+,S+ }
{$ELSE }
  {$D-,I-,L-,R-,S- }
{$ENDIF }

Unit ERROR;

interface

function MsgError(num : byte) : string;

implementation

type  StrError = string[28];
const INDEFERROR = 'ERREUR INDEFINIE';
      LgErrors = 13;
      Errors : array[1..LgErrors] of StrError = (
        'FICHIER INTROUVABLE',                       { 01 (02) }
        'CHEMIN D''ACCES INTROUVABLE',               {    (03) }
        'TROP DE FICHIERS OUVERTS',                  {    (04) }
        'ACCES AU FICHIER INTERDIT',                 {    (05) }
        'UNITE DE DISQUE INVALIDE',                  {    (15) }

        'ERREUR DISQUE EN LECTURE',                  { 06 (100) }
        'ERREUR DISQUE EN ECRITURE',                 { 07 (101) }

        'UNITE DE DISQUE PROTEGEE',                  { 08 (150) }
        'UNITE DE DISQUE NON RECONNUE',              {    (151) }
        'UNITE DE DISQUE NON PRETE',                 {    (152) }
        'ERREUR D''ECRITURE',                        {    (160) }
        'ERREUR DE LECTURE',                         { 12 (161) }
        'PAS ASSEZ DE MEMOIRE'                       { 13 (8) }
        );
      LongDosError = 15;
      DosError : array[1..LongDosError] of byte =
               ( 0,1,2,3,4,0,0,13,0,0,0,0,0,0,5 );
      LongIOError = 101;
      IOError : array[100..101] of byte = ( 6,7 );
      LongCritError = 161;
      CritError : array[150..LongCritError] of byte =
                ( 8,9,10,0,0,0,0,0,0,0,11,12 );

function MsgError(num : byte) : string;
var NumTxt : string[14];
begin
  if (num>=1) and (num<=LongDosError) and (DosError[num]<>0) then
    MsgError := Errors[DosError[num]]  (* Error DOS *)
  else
    if (num>=100) and (num<=LongIOError) and (IOError[num]<>0) then
      MsgError := Errors[IOError[num]]   (* Error IO *)
    else
     if (num>=150) and (num<=LongCritError) and (CritError[num]<>0) then
          MsgError := Errors[CritError[num]] (* Error Crit *)
     else
       begin
         Str(num,NumTxt);
         NumTxt := ' ('+NumTxt+')';
         MsgError := INDEFERROR+NumTxt; { par dfaut }
       end;
end;

end.
