{********************************
 *                               *
 *           MENUCON             *
 *                               *
 ********************************}

function MinitelChoix : boolean;
begin
  if (inter.SelectField=FieldMinitel) then
   if inter.BtnGauche then
    begin
      MinitelChoix := true;
      ForceGlobalRefresh;
      MinReset;
      ReadyForRAff;
    end
   else
    begin
      MinitelChoix := true;
      ForceGlobalRefresh;
      MinReset;
      ReadyForRAff;
    end
  else MinitelChoix := false;
end;

procedure InstallFldPanel;
{ panel et graph }
var index : word;
begin
  for index := FieldPanel to FieldPanel+NbreAtt-1 do ChsFld(index);
  for index := FieldGraphik to FieldGraphik+5 do ChsFld(index);
  ChsFld(131);    { Selecteur de jeux graphique }
end;

Procedure InstallFldEga;
Var i : Byte;
Begin
 If VideoEGA Then
  Begin
   For i := FieldEga To FieldEga+5 Do ChsFld(i);
   If VideoVGA Then ChsFld(152);
   ChsFld(153);
  End;
End;

procedure ChsFldStd;
begin
  InstallFldPanel;
  ChsFld(FieldMem);
  ChsFld(FieldMinitel);
  ChsFld(FieldDRCS);
end;



Procedure AffEgaVAttr;
Var i : Byte;
    a : Word;
    o : Boolean;
    f : Byte;
    z : Byte;
Begin
 If VideoEGA Then
  Begin
   For i := 0 To 3 Do
    Begin
     a := 1 Shl i;
     o := (Cfg.VAttr And a)<>0;
     Case a Of
      VATTR_GRAPH : f := 1;
      VATTR_RVS   : f := 2;
      VATTR_DRCS  : f := 3;
      VATTR_COLORS: f := 4;
     Else f := 0;
     End;
     If f<>0 Then
      Begin
       If o Then z := SurEvidenceField
       Else z := CDisp;
       FieldAspect(FieldEga+f,z);
      End;
    End;
  End;
End;


Function EGAChoix( Var Ram : VDispRam; Var DRCS : VDispRamDRCS; LZ, Actif : Boolean ) : Boolean;
Begin
 If (Inter.SelectField>=FieldEga) And
    (Inter.SelectField<=FieldEga+5) Then
  Begin
   Case Inter.SelectField Of
    FieldEga     : Cfg.VAttr := 0;
    FieldEga+1   : Cfg.VAttr := Cfg.VAttr Xor VATTR_GRAPH;
    FieldEga+2   : Cfg.VAttr := Cfg.VAttr Xor VATTR_RVS;
    FieldEga+3   : Cfg.VAttr := Cfg.VAttr Xor VATTR_DRCS;
    FieldEga+4   : Cfg.VAttr := Cfg.VAttr Xor VATTR_COLORS;
    FieldEga+5   : Cfg.VAttr := $FFFF;
   End;

   AffAllLnShow(Ram,LZ,Actif);
   AffEgaVAttr;

   EgaChoix := TRUE;
  End
 Else
  If Inter.SelectField=152 Then
   Begin
    Cfg.Grey := Not(Cfg.Grey);
    If Cfg.Grey Then FixPalBWVGA
    Else FixPalCoVGA;
    EgaChoix := TRUE;
   End
  Else
   If Inter.SelectField=153 Then
    Begin
     LoadMatrice(DRCS[0],94,1,MatGP0+1);
     LoadMatrice(DRCS[1],94,1,MatGP1+1);
{     ResetVideoEGA; }
     EgaChoix := TRUE;
    End
   Else EgaChoix := FALSE;
End;


Function DRCSChoix : Boolean;
Begin
 If Inter.SelectField=FieldDRCS Then
  Begin
   SwapDRCSActif;
   DRCSChoix := TRUE;
  End
 Else DRCSChoix := FALSE;
End;


function StdChoix : boolean;
begin
  StdChoix := PanelChoix or MemChoix or MinitelChoix or DRCSChoix;
end;

procedure WaitRelache;
begin
  repeat
    MouseStatus;
  until not(ButtonL or ButtonR)
end;

procedure ForceMouseTo(x,y : word);
var reg : registers;
begin
  reg.AX := 4;
  reg.CX := x;
  reg.DX := y;
  IntMouse(reg);
end;

procedure CoordZn(Zn : Zn_Rec; x,y : byte);
var buf : string[3];
  procedure Complete(valeur: byte);
  begin
    Str(valeur:2,buf);
    if buf[1]=' ' then buf[1] := '0';
  end;
const tab : array[1..5] of string[16] = (
          '  C.--          ',
          'L.--ͻ    ',
          '    S.---     ',
          '    ͼL.--',
          '          C.--  ' );
var i : byte;
begin
  Complete(Zn.x+1);
  move(buf[1],tab[1,5],2);
{ move(buf[1],tab[5,5],2); }
  Complete(Zn.y);
  move(buf[1],tab[2,3],2);
{ move(buf[1],tab[2,15],2); }
  Complete(Zn.x+Zn.lg);
{ move(buf[1],tab[1,13],2); }
  move(buf[1],tab[5,13],2);
  Complete(Zn.y+Zn.ht-1);
{ move(buf[1],tab[4,3],2); }
  move(buf[1],tab[4,15],2);
  str(Zn.ht*Zn.lg:4,buf);
  i := 1;
  while (i<3) and (buf[i]=' ') do
    begin
      buf[i] := '0';
      inc(i);
    end;
  move(buf[1],tab[3,8],3);
  for i:=1 to 5 do WrtScr(tab[i],x,i+y-1,TNet);
end;

procedure AffDataShow(x,y : byte);
{ considere comme active, toujours! }
begin
 With cM^.Ram[y,x] Do AffVdtChar(Car,x,y,Att);
end;

procedure AffZnShow(Zn : Zn_Rec);
var l,c : byte;
begin
  with Zn do
    for l := y to y+ht-1 do
      for c := x to x+lg-1 do AffDataShow(c,l);
end;

(*
procedure AffDataShowCadre( x, y : byte);
{ considere comme active, toujours! }
Var a : Byte;
begin
 With cM^.Ram[y,x] Do
  if Car=#0 then WrtDt(RIEN,x+20,y,CCadreEvol)
  else
   Begin
    If Att And DRCS=0 Then a := CCadreEvol Else a := CCadreEvolDRCS;
    if (Att and Graphik)=0 then
     Begin
      WrtDt(Byte(Car),x+20,y,a);
     End
    else
     Begin
      WrtDt(CarGraphik,x+20,y,a);
     End;
   End;
end;

procedure AffDataShowMove(x,y : byte);
{ considere comme active, toujours! }
begin
 With cM^.Ram[y,x] Do
  if Car = #0 then WrtDt(RIEN,x+20,y,CMove)
  else
    if (Att and Graphik)=0 then
      WrtDt(Byte(Car),x+20,y,CMove)
    else
      WrtDt(CarGraphik,x+20,y,CMove);
end;
*)

type StdChoix_Proc = procedure( ZnPage : byte; ZnCadre : Zn_Rec );

procedure Exe_Choix( ZnPage : byte; ZnCadre : Zn_Rec; proc : StdChoix_Proc );
begin
  KeepMem(ZnPage,ZnCadre.y,ZnCadre.ht);
  proc(ZnPage,ZnCadre);
  if ZnPage=NumPage then AffZnShow(ZnCadre);
end;

{$F+}
procedure InvGraphisme(ZnPage : byte; ZnCadre : Zn_Rec);
{$F-}
var ligne,colonne : byte;
    Ram : PVDispRam;
(*
    f : File Of Byte;
    b : Byte;
*)
begin
(*
  Assign(f,'LOGO.BIN');
  Rewrite(f);

  Ram := @TabMem[ZnPage]^.Ram;
  with ZnCadre do
    for ligne := y to y+ht-1 do
      for colonne := x to x+lg-1 do
        begin
          with Ram^[ligne,colonne] do
           Begin
            Write(f,Byte(Car));
            b := Lo(Att);
            Write(f,b);
            b := Hi(Att);
            Write(f,b);
           End;
        end;

  Close(f);
*)
  Ram := @TabMem[ZnPage]^.Ram;
  with ZnCadre do
    for ligne := y to y+ht-1 do
      for colonne := x to x+lg-1 do
        begin
          with Ram^[ligne,colonne] do
            if (Car<>#0) and (att and Graphik<>0) then
              begin
                Car := Char(GraphCorrector((InvGraphCorrector(Byte(Car)) xor 63)+32));
              end;
        end;
end;

{$F+}
procedure EchangeCouleurs(ZnPage : byte; ZnCadre : Zn_Rec);
{$F-}
var ligne,colonne : byte;
    Ram : PVDispRam;
begin
  Ram := @TabMem[ZnPage]^.Ram;
  with ZnCadre do
    for ligne := y to y+ht-1 do
      for colonne := x to x+lg-1 do
        begin
          with Ram^[ligne,colonne] do
            if (Car<>#0) then
              begin
                att := (att and not(63)) or (((att and 56) shr 3) or
                       ((att and 7) shl 3));
              end;
        end;
end;

type EclAss_Proc = procedure(ZnPage : byte; ZnCadre : Zn_Rec; Trait,Fond : boolean );

{$F+}
procedure Eclaircir(ZnPage : byte; ZnCadre : Zn_Rec; Trait,Fond : boolean );
{$F-}
var ligne,colonne : byte;
    Ram : PVDispRam;
begin
  Ram := @TabMem[ZnPage]^.Ram;
  with ZnCadre do
    for ligne := y to y+ht-1 do
      for colonne := x to x+lg-1 do
        begin
          with Ram^[ligne,colonne] do
            if (Car<>#0) then
              begin
                if Trait then att := (att and not(7)) or (((att and 7)+1)and 7);
                if Fond then
                  att := (att and not(56)) or
                         (((((att shr 3) and 7)+1) and 7) shl 3);
              end;
        end;
end;

{$F+}
procedure Assombrir(ZnPage : byte; ZnCadre : Zn_Rec; Trait,Fond : boolean );
{$F-}
var ligne,colonne : byte;
    Ram : PVDispRam;
begin
  Ram := @TabMem[ZnPage]^.Ram;
  with ZnCadre do
    for ligne := y to y+ht-1 do
      for colonne := x to x+lg-1 do
        begin
          with Ram^[ligne,colonne] do
            if (Car<>#0) then
              begin
                if Trait then att := (att and not(7)) or (((att and 7)-1)and 7);
                if Fond then
                  att := (att and not(56)) or
                         (((((att shr 3) and 7)-1) and 7) shl 3);
              end;
        end;
end;

{$F+}
procedure PropAttInShow(ZnPage : byte; ZnCadre : Zn_Rec);
{$F-}
var ligne,colonne : byte;
    PanelWork : word;
    TempoPanel : word;
    index : byte;
    Ram : PVDispRam;
begin
  Ram := @TabMem[ZnPage]^.Ram;
  with ZnCadre do
    for ligne := y to y+ht-1 do
      for colonne := x to x+lg-1 do
        begin
          With Ram^[ligne,colonne] Do
           If Car<>#0 then
            begin
              { eteind le format et graphik }
              PanelWork := GetPanel And Not(Taille);
              { on oublie pas l'activite des att et surtout, on }
              { on reprend le format existant                   }
              TempoPanel := Att;
              for index:=0 to NbreAtt-1 do
                if not(AttActif[index]) or (index=2) then
                  WrtAtt(PanelWork,index,ReadAtt(TempoPanel,index));
              Att := PanelWork or (Att And (Graphik+DRCS+Delim))
            end;
        end;
end;

type Remp_Proc = procedure(ZnPage: byte;
                           ZnCadre : Zn_Rec; Data : byte; PanelRef : word);

{$F+}
procedure RemplirShowWith(ZnPage: byte;
                          ZnCadre : Zn_Rec; Data : byte; PanelRef : word);
{$F-}
var ligne,colonne : byte;
    Base : VDispRamEl;
    PanelWork : word;
    index : byte;
    Ram   : PVDispRam;
begin
  Ram := @TabMem[ZnPage]^.Ram;
  PanelRef := PanelRef and (65535-192); { vire le format }
  with ZnCadre do
    for ligne := y to y+ht-1 do
      for colonne := x to x+lg-1 do
        begin
          PanelWork := PanelRef;
          With Ram^[ligne,colonne] Do
           Begin
            Base.Car := Car;
            Base.Att := Att;
            if Base.Car=#0 then Base.Att := BasePanel;
            for index:=0 to NbreAtt-1 do
              if (index<>2) and not(AttActif[index]) then
                WrtAtt(PanelWork,index,ReadAtt(Base.Att,index));
            Att := PanelWork;
            Car := Char(data);
           End;
        end;
end;

{$F+}
procedure SupprVidesShowWith(ZnPage: byte;
                             ZnCadre : Zn_Rec; Data : byte; PanelRef : word);
{$F-}
var ligne,colonne : byte;
    PanelWork : word;
    index : byte;
    Ram   : PVDispRam;
    _Att  : word;
begin
  Ram := @TabMem[ZnPage]^.Ram;
  PanelRef := PanelRef and (65535-192); { vire le format }
  with ZnCadre do
    for ligne := y to y+ht-1 do
      for colonne := x to x+lg-1 do
        begin
          With Ram^[ligne,colonne] Do
           if Car=#0 then
            begin
              PanelWork := PanelRef;
              _Att := BasePanel;
              for index:=0 to NbreAtt-1 do
                if (index<>2) and not(AttActif[index]) then
                  WrtAtt(PanelWork,index,ReadAtt(_Att,index));
              Att := PanelWork;
              Car := Char(data);
            end;
        end;
end;

function RempInShow(titre,t_mod : string;
                    ZnPage : byte; ZnCadre : Zn_Rec;
                    NumFile,NumFileCoord : byte; proc : Remp_Proc ) : boolean;
  procedure DoIt( car : byte; Att : Word );
  begin
    KeepMem(ZnPage,ZnCadre.y,ZnCadre.ht);
    Proc(ZnPage,ZnCadre,car,Att);
    if ZnPage=NumPage then
     Begin
      AffZnShow(ZnCadre);
     End;
  end;
var EndBoucle : boolean;
    good : boolean;
    KeyDispo : boolean;
    status : boolean;

 Procedure Abandon;
 begin
  EndBoucle := true;
  Good := false;
 end;

begin
  NewMenu(titre,PointNothing,0);
  RstZnTo(NumFileCoord,61,8);
  ChsFldStd;
  WrtScr(CentreString('Tapez le',18,32),61,5,CMiNet);
  WrtScr(CentreString('caractre de',18,32),61,6,CMiNet);
  WrtScr(CentreString(t_mod,18,32),61,7,CMiNet);
  Good := true;
  EndBoucle := false;
  repeat
    status := Interaction;
    if Key<>#0 then
     begin
      If Not(Funct) And (Key=#27) Then Abandon
      Else
       if not((status) and (KeyInPanel)) then
        if not(PanelCMD) then
         if PCKeyData(DRCSActif) then
           begin
             DoIt(byte(KeyCompo),GetPanelCar);
             EndBoucle := true;
             Good := true;
           end
         else
           if (Key=#7) and not(Funct) then
             begin
               DoIt(CalcGraphCode(PB.Graphik,DRCSActif),GetPanelCar Or Graphik);
               EndBoucle := true;
               Good := true;
             end;
     end
    else
      if status then
        if StdChoix then
          begin
            if (inter.SelectField = FieldMem) and
               (ZnPage=NumPage) then RstZn(NumFile);
          end
        else
          if (inter.SelectField=19) then Abandon
          else NoFieldLand;
  until EndBoucle;
  EndNewMenu;
  RempInShow := good;
end;

function GestMoveZn(ZnPage : byte; { cadre origine de cette page! }
                    var depart : Zn_Rec; var dest : Zn_Rec;
                    NumSave,NumFileCoord : byte ) : boolean;
const ZnCtrl : Zn_Rec = (x:61; y:5; lg:18; ht:7);
      XC=62;
      YC=6;

      XL=62;
      YL=18;
type Zn_RecInt = record
                   x,y,lg,ht : shortint;
                 end;
  procedure MoveZn(var courant : Zn_RecInt;
                   origine : Zn_RecInt; x,y : byte);
  var ras : Zn_RecInt;
      ligne,col : byte;
      DecalX,DecalY : byte;
      long,haut : byte;
      Zn : Zn_Rec;
  begin
    { definition de la vrai zn en mouvement dans 'ras' }
    ras.x := x+20-(origine.lg div 2);
    ras.y := y-(origine.ht div 2);
    ras.lg := origine.lg;
    ras.ht := origine.ht;

    if ras.x<PXhaut+20 then
      begin { x sort des limites a gauche }
        DecalX := PXhaut+20-ras.x;
        long := origine.lg-DecalX;
      end
    else
      begin
        DecalX := 0;
        if ras.x+ras.lg-1>PXbas+20 then { depassement de longueur }
          long := PXbas+20-ras.x+1
        else long := origine.lg;
      end;

    if ras.y<PYhaut then
      begin { x sort des limites a gauche }
        DecalY := PYhaut-ras.y;
        haut := origine.ht-DecalY;
      end
    else
      begin
        DecalY := 0;
        if ras.y+ras.ht-1>PYbas then { depassement de longueur }
          haut := PYbas-ras.y+1
        else haut := origine.ht;
      end;

    { la partie reelle a represente est : }
    { de ras.x + DecalX }
    { de ras.y + DecalY }
    { de long et haut   }
    for ligne := 1 to haut do
      ToScr(ptr(FileZn[NumSave].seg,
                FileZn[NumSave].ofs+(DecalX+(DecalY+ligne-1)*Origine.lg)*2),
            ras.x+DecalX,(ligne-1)+ras.y+DecalY,long);

    Zn.x := ras.x+DecalX;
    Zn.y := ras.y+DecalY;
    Zn.lg := long;
    Zn.ht := haut;

    for ligne := courant.y to courant.y+courant.ht-1 do
      if (ligne<Zn.y) or (ligne>Zn.y+Zn.ht-1) then
        for col := courant.x to courant.x+courant.lg-1 do
          AffDataShow(col-20,ligne)
      else
        for col := courant.x to courant.x+courant.lg-1 do
          if (col<Zn.x) or (col>Zn.x+Zn.lg-1) then
            AffDataShow(col-20,ligne);

    courant.x := Zn.x;
    courant.y := Zn.y;
    courant.lg := Zn.lg;
    courant.ht := Zn.ht;
{    dec(Zn.x,20);
    dec(Zn.y);
    CoordZn(Zn,MZnCoord.x,MZnCoord.y); }
  end;

var Rcourant,Rorigine : Zn_RecInt;
    EndBoucle,Good,ZnPlace : boolean;
    Mligne,Mcolonne : byte;
    Zn ,ZnTemp  : Zn_Rec;
    cx, cy  : byte;

 Procedure Abandon;
 begin
   EndBoucle := true;
   Good := false;
 end;

label direct;
begin
  Rcourant.x := depart.x+20;
  Rcourant.y := depart.y;
  Rcourant.lg := depart.lg;
  Rcourant.ht := depart.ht;
  Rorigine := Rcourant;

  ZnTemp.x := Rcourant.x;
  ZnTemp.y := Rcourant.y;
  ZnTemp.lg := Rcourant.lg;
  ZnTemp.ht := Rcourant.ht;

  ChsFldStd;
  ChsFld(107);
  AffZnShow(depart);
  RstZnTo(NumFileCoord,XL-1,YL-1);
  ZnPlace := false;
  EndBoucle := false;
  repeat
    Mligne := MouseL;
    Mcolonne := MouseC;
    if Interaction then
      begin
        if Key<>#0 then
         Begin
          If Not(Funct) And (Key=#27) Then Abandon;
         End
        Else
         if StdChoix then
           begin
             { si le choix est Mem alors passer ZnPlace a False }
             if inter.SelectField=FieldMem then
               ZnPlace := false;
           end
         else
          if inter.SelectField=19 then Abandon
          else
            if inter.SelectField=107 then
              begin
                cx := depart.x+(depart.lg div 2);
                cy := depart.y+(depart.ht div 2);
                EndBoucle := TRUE;
                Good := TRUE;
                goto direct;
              end;
      end
    else
     If Not(Funct) And (Key=#27) Then Abandon
     Else
      begin
        if ButtonR then
          begin
            WaitRelache;
            EndBoucle := true;
            good := false;
          end
        else
          if ButtonL then
            begin
              WaitRelache;
              EndBoucle := true;
              good := true;
            end
          else
            begin
              cx := CurX;
              cy := CurY;
direct:       if (cx+20<>Mcolonne) or (cy<>Mligne) then
                begin
                  MoveZn(Rcourant,Rorigine,cx,cy);
                  dest.x := Rcourant.x-20;
                  dest.y := Rcourant.y;
                  dest.lg := Rcourant.lg;
                  dest.ht := Rcourant.ht;
                  if ZnPlace=FALSE then CCdrZn(ZnCtrl,CDRNORM,CSep);
                  CoordZn(dest,XC,YC);
                  ZnPlace := true;
                {  gotoxy(1,15);
                  writeln('x=',Rcourant.x,' y=',Rcourant.y,'.');
                  writeln('l=',Rcourant.lg,' h=',Rcourant.ht,'.'); }
                end;
            end;
      end;
  until EndBoucle;
  dest.x := Rcourant.x-20;
  dest.y := Rcourant.y;
  dest.lg := Rcourant.lg;
  dest.ht := Rcourant.ht;
  if dest.x<=depart.x then depart.x := depart.x+(depart.lg-dest.lg);
  if dest.y<=depart.y then depart.y := depart.y+(depart.ht-dest.ht);
  depart.lg := Rcourant.lg;
  depart.ht := Rcourant.ht;

  if not(Good) then
    begin
      AffZnShow(dest);
      if (ZnPage=NumPage) then RstZn(NumSave);
    end
  else Good := ZnPlace; { securite peut etre superflu ... }
  GestMoveZn := Good;
end;

procedure CopyBlock(ZnPage : byte; org,but : Zn_Rec);
var pgBlock : PVDispRam;
    y : byte;
    Cy : ShortInt;
    Lgx : integer;
begin
{  gotoxy(1,10);
  writeln('x=',org.x,' y=',org.y,'.');
  writeln('l=',org.lg,' h=',org.ht,'.');
  writeln('x=',but.x,' y=',but.y,'.');
  writeln('l=',but.lg,' h=',but.ht,'.');
  }
  Cy := but.y-org.y;
  Lgx := org.lg*SizeOf(VDispRamEl);
  new(pgBlock);
  for y := org.Y to org.Y+org.ht-1 do
    move(TabMem[ZnPage]^.Ram[y,org.x],pgBlock^[y+Cy,but.x],Lgx);
  for y := but.Y to but.Y+but.ht-1 do
    move(pgBlock^[y,but.x],cM^.Ram[y,but.x],Lgx);
  Dispose(pgBlock);
end;

procedure EchangerBlock(ZnPage : byte; org,but : Zn_Rec);
var pgBlock : PVDispRam;
    pgBlock2 : PVDispRam;
    y : byte;
    Cy,Cy2 : ShortInt;
    Lgx : integer;
begin
  Cy := but.y-org.y;
  Cy2 := but.y-org.y;
  Lgx := org.lg*SizeOf(VDispRamEl);
  new(pgBlock);
  new(pgBlock2);
  for y := org.Y to org.Y+org.ht-1 do
    move(TabMem[ZnPage]^.Ram[y,org.x],pgBlock^[y+Cy,but.x],Lgx);
  for y := but.Y to but.Y+but.ht-1 do
    move(cM^.Ram[y,but.x],pgBlock2^[org.y+y-but.y,org.x],Lgx);
{    MemVShow[ZnPage] }
  for y := org.y to org.y+org.ht-1 do
    move(pgBlock2^[y,org.x],TabMem[ZnPage]^.Ram[y,org.x],Lgx);
  for y := but.Y to but.Y+but.ht-1 do
    move(pgBlock^[y,but.x],cM^.Ram[y,but.x],Lgx);
  Dispose(pgBlock2);
  Dispose(pgBlock);
end;

function MoveAndCopier(ZnPage:byte; ZnCadre : Zn_Rec;
                       NumFile,NumFileCoord : byte) : boolean;
var dest : Zn_Rec;
begin
  NewMenu('Copier',PointNothing,0);
  if GestMoveZn(ZnPage,ZnCadre,dest,NumFile,NumFileCoord) then
    begin
      KeepMem(NumPage,dest.y,dest.ht);
      CopyBlock(ZnPage,ZnCadre,dest);
      AffZnShow(dest);
      MoveAndCopier := true;
    end
  else MoveAndCopier := false;
  EndNewMenu;
end;

function ThisIn(x,y : byte; Zn : Zn_Rec) : boolean;
begin
  ThisIn :=  (x>=Zn.x) and (x<=Zn.x+Zn.lg-1) and
             (y>=Zn.y) and (y<=Zn.y+Zn.ht-1);
end;

procedure VideBlock(Zn,msk : Zn_Rec);
var x,y : byte;
begin
  for y := Zn.y to Zn.y+Zn.ht-1 do
    for x := Zn.x to Zn.x+Zn.lg-1 do
      if not(ThisIn(x,y,msk)) then cM^.Ram[y,x] := vierge;
end;

{$F+}
procedure VideZn(ZnPage: byte; Zn : Zn_Rec);
{$F-}
var ligne,colonne : byte;
begin
  with Zn,TabMem[ZnPage]^ do
    for ligne := y to y+ht-1 do
      begin
        for colonne := x to x+lg-1 do Ram[ligne,colonne]:=vierge;
      end;
end;

function MoveAndDeplacer(ZnPage : byte; ZnCadre : Zn_Rec;
                         NumFile,NumFileCoord : byte) : boolean;
var dest : Zn_Rec;
    save : Zn_Rec;
begin
  save := ZnCadre;
  NewMenu('Dplacer',PointNothing,0);
  if GestMoveZn(ZnPage,ZnCadre,dest,NumFile,NumFileCoord) then
    begin
      KeepMem(ZnPage,ZnCadre.y,ZnCadre.ht);
      KeepMem(NumPage,dest.y,dest.ht);
      CopyBlock(ZnPage,ZnCadre,dest);
      if ZnPage=NumPage then
        begin
        VideBlock(save,dest);
        AffZnShow(save);
        end
      else
        begin
          VideZn(ZnPage,save);
        end;
      AffZnShow(dest);
      MoveAndDeplacer := true;
    end
  else MoveAndDeplacer := false;
  EndNewMenu;
end;

function MoveAndEchanger(ZnPage : byte; ZnCadre : Zn_Rec;
                         NumFile,NumFileCoord : byte) : boolean;
var dest : Zn_Rec;
    save : Zn_Rec;
begin
  save := ZnCadre;
  NewMenu('Echanger',PointNothing,0);
  if GestMoveZn(ZnPage,ZnCadre,dest,NumFile,NumFileCoord) then
    begin
      KeepMem(ZnPage,ZnCadre.y,ZnCadre.ht);
      KeepMem(NumPage,dest.y,dest.ht);
      EchangerBlock(ZnPage,ZnCadre,dest);
      if ZnPage=NumPage then
       Begin
        AffZnShow(save);
       End;
      AffZnShow(dest);
      MoveAndEchanger:= true;
    end
  else MoveAndEchanger := false;
  EndNewMenu;
end;

procedure CalquerBlock(ZnPage:byte; org,but : Zn_Rec);
var pgBlock : PVDispRam;
    x,y : byte;
    Cy  : ShortInt;
    Lgx : integer;
begin
  Cy := but.Y-org.Y;
  Lgx := org.lg*SizeOf(VDispRamEl);
  new(pgBlock);
  for y := org.Y to org.Y+org.ht-1 do
    move(TabMem[ZnPage]^.Ram[y,org.X],pgBlock^[y+Cy,but.x],Lgx);
  for y:=but.Y to but.Y+but.ht-1 do
    for x:=but.X to but.X+but.lg-1 do
      begin
        if pgblock^[y,x].Car<>#0 then cM^.Ram[y,x]:=pgblock^[y,x];
      end;
  Dispose(pgBlock);
end;

function MoveAndCalquer(ZnPage : byte; ZnCadre : Zn_Rec;
                        NumFile,NumFileCoord : byte) : boolean;
var dest : Zn_Rec;
begin
  NewMenu('Calquer',PointNothing,0);
  if GestMoveZn(ZnPage,ZnCadre,dest,NumFile,NumFileCoord) then
    begin
      keepMem(NumPage,dest.y,dest.ht);
      CalquerBlock(ZnPage,ZnCadre,dest);
      AffZnShow(dest);
      MoveAndCalquer := true;
    end
  else MoveAndCalquer := false;
  EndNewMenu;
end;


procedure CadrageChoix;
const ZnCtrl : Zn_Rec = (x:61; y:5; lg:18; ht:7);
(*      ZnTemp : Zn_Rec = (x:1; y:16; lg:18; ht:7); *)
var NumFileCoord : byte;
(*
    NumFileTemp  : byte;
*)
  function CadrageAction(ZnCadre : Zn_Rec) : boolean;
  var ZnPage : byte;
      NumFileCadre : byte;
  function EclAssChoix( titre : string; mod_coul : EclAss_Proc ) : boolean;
  const TabLux : array[1..3] of StrChoix = ('Trait','Fond','Trait & Fond');
  var status,EndBoucle, Good : boolean;

   Procedure Abandon;
   Begin
    EndBoucle := true;
    good := false;
   End;

  begin
    NewMenu(titre,TabLux,3);
    ChsFldStd;
    EndBoucle := FALSE;
    Good := FALSE;
    repeat
      status := Interaction;
      if Key<>#0 then
        begin
         If Not(Funct) And (Key=#27) Then Abandon
         Else
          if not((status) and (KeyInPanel)) then status := PanelCMD; { bidon }
        end
      else
       if status then
        if StdChoix then
         begin
           if (inter.SelectField=FieldMem) and
              (ZnPage=NumPage) then RstZn(NumFileCadre);
         end
        else
         begin
          case inter.SelectField of
            19 : begin
                  Abandon;
                 end;
            21 : begin { trait }
                   KeepMem(ZnPage,ZnCadre.y,ZnCadre.ht);
                   mod_coul(ZnPage,ZnCadre,TRUE,FALSE);
                   if ZnPage=NumPage then
                    Begin
                     AffZnShow(ZnCadre);
                    End;
                   EndBoucle := true;
                   Good := true;
                 end;
            23 : begin { fond }
                   KeepMem(ZnPage,ZnCadre.y,ZnCadre.ht);
                   mod_coul(ZnPage,ZnCadre,FALSE,TRUE);
                   if ZnPage=NumPage then
                    Begin
                     AffZnShow(ZnCadre);
                    End;
                   EndBoucle := true;
                   Good := true;
                 end;
            25 : begin { trait & fond }
                   KeepMem(ZnPage,ZnCadre.y,ZnCadre.ht);
                   mod_coul(ZnPage,ZnCadre,TRUE,TRUE);
                   if ZnPage=NumPage then
                    Begin
                     AffZnShow(ZnCadre);
                    End;
                   EndBoucle := true;
                   Good := true;
                 end;
          end;
         end;
    until EndBoucle;
    EndNewMenu;
    EclAssChoix := Good;
  end;
  function AutresChoix : boolean;
  const LgTab = 6;
        Tab : array[1..LgTab] of StrChoix = (
                'Inverser graph.','Echanger couleurs',
                'Eclaircir','Assombrir','Suppr. Vides',
                'Espace de compo.' );
  var status,EndBoucle, Good : boolean;

   Procedure Abandon;
   Begin
    EndBoucle := true;
    good := false;
   End;

  begin
    NewMenu('Zonage',Tab,LgTab);
    ChsFldStd;
    EndBoucle := FALSE;
    Good := FALSE;
    repeat
      status := Interaction;
      if Key<>#0 then
        begin
         If Not(Funct) And (Key=#27) Then Abandon
         Else
          if not((status) and (KeyInPanel)) then status := PanelCMD; { bidon }
        end
      else
       if status then
        if StdChoix then
         begin
           if (inter.SelectField=FieldMem) and
              (ZnPage=NumPage) then RstZn(NumFileCadre);
         end
        else
         begin
          case inter.SelectField of
            19 : begin
                  Abandon;
                 end;
            21 : begin { inverser }
                   Exe_Choix(ZnPage,ZnCadre,InvGraphisme);
                   EndBoucle := true;
                   Good := true;
                 end;
            23 : begin { echanger }
                   Exe_Choix(ZnPage,ZnCadre,EchangeCouleurs);
                   EndBoucle := true;
                   Good := true;
                 end;
            25 : begin { eclaircir }
                   EndBoucle := EclAssChoix(Tab[3],Eclaircir);
                   Good := EndBoucle;
                 end;
            27 : begin { assombrir }
                   EndBoucle := EclAssChoix(Tab[4],Assombrir);
                   Good := EndBoucle;
                 end;
            29 : begin { suppr.vides }
            (*
                   RstZn(NumFileTemp); *)
                   EndBoucle := RempInShow(Tab[5],'remplacement',ZnPage,ZnCadre,
                                         NumFileCadre,NumFileCoord,
                                         SupprVidesShowWith);
                   (*
                   if not(EndBoucle) then RstZnTo(NumFileCoord,ZnTemp.x,ZnTemp.y);
                   *)
                   Good := true;
                 end;
            31 : begin { espace de compo }
                   PXhaut := ZnCadre.X;
                   PYhaut := ZnCadre.Y;
                   PXbas := ZnCadre.X+ZnCadre.lg-1;
                   PYbas := ZnCadre.Y+ZnCadre.ht-1;
                   EndBoucle := true;
                   Good := true;
                   ResetAffCompo := true;
                 end;
          end;
         end;
    until EndBoucle;
    EndNewMenu;
    AutresChoix := Good;
  end;
  const LgTab = 7;
        Tab : array[1..LgTab] of StrChoix = ( 'Dplacer','Copier','Calquer',
              'Echanger','Remplir','Propager attributs','Vider');
  var EndBoucle,Good : boolean;
      ligne,colonne : byte;
      ZnReel : Zn_Rec;
      status : boolean;

   Procedure Abandon;
   Begin
    EndBoucle := true;
    good := false;
   End;

  begin
  ZnPage := NumPage; { numro de page ou est le cadre!! }
  ZnReel.x := ZnCadre.x+20;
  ZnReel.y := ZnCadre.y;
  ZnReel.lg := ZnCadre.lg;
  ZnReel.ht := ZnCadre.ht;
  NumFileCadre := SaveZn(ZnReel);
  NewMenu('Zonage',Tab,7);

  ChsFld(37);
  MakeTrait(20,2,2);
  WrtScr(CentreString('Autres choix',18,32),61,21,CDisp);

  ChsFldStd;
  EndBoucle := false;
  Good := false;
  repeat
    status := Interaction;
    if Key<>#0 then
      begin
       If Not(Funct) And (Key=#27) Then Abandon
       Else
        if not((status) and (KeyInPanel)) then status := PanelCMD; { bidon }
      end
    else
     if status then
      if StdChoix then
       begin
         if (inter.SelectField=FieldMem) and
            (ZnPage=NumPage) then RstZn(NumFileCadre);
       end
      else
       begin
        case inter.SelectField of
          19 : begin
                Abandon;
               end;
          21,23,25,27,29 :
            begin
            (*
            RstZn(NumFileTemp);
            *)
            case inter.SelectField of
             21:begin { deplacer }
                 EndBoucle := MoveAndDeplacer(ZnPage,ZnCadre,
                                              NumFileCadre,NumFileCoord);
                 good := true;
                end;
             23:begin { copier }
                 EndBoucle := MoveAndCopier(ZnPage,ZnCadre,
                                            NumFileCadre,NumFileCoord);
                 good := true;
                end;
             25:begin { calquer }
                 Endboucle := MoveAndCalquer(ZnPage,Zncadre,
                                             NumFileCadre,NumFileCoord);
                 good := true;
                end;
             27:begin
                 Endboucle := MoveAndEchanger(ZnPage,Zncadre,
                                              NumFileCadre,NumFileCoord);
                 good := true;
                end;
             29:begin { remplir }
                 EndBoucle := RempInShow(Tab[5],'remplissage',ZnPage,ZnCadre,
                                         NumFileCadre,NumFileCoord,
                                         RemplirShowWith);
                 Good := true;
                end;
             end;
            (*
            if not(EndBoucle) then RstZnTo(NumFileCoord,ZnTemp.x,ZnTemp.y);
            *)
            end;
          31 : begin { propager attributs }
                 Exe_Choix(ZnPage,ZnCadre,PropAttInShow);
                 EndBoucle := true;
                 Good := true;
               end;
          33 : begin { vider }
                 Exe_Choix(ZnPage,ZnCadre,VideZn);
                 good := true;
                 EndBoucle := true;
               end;
          37 : begin { autres choix }
                 EndBoucle := AutresChoix;
                 if EndBoucle then Good := TRUE;
               end;
        end;
       end;
  until EndBoucle;
  EndNewMenu;
  CloseZn(NumFileCadre);
  CadrageAction := Good;
  end;

  function ZnGet(var courant : Zn_Rec) : boolean;
    procedure ZnEnForm(Zn : Zn_Rec);
    begin
      Inc(Zn.x,20);
      AspZn(Zn,CCadreEvol);
    end;
    function PosIn(x,y : byte; Zn : Zn_Rec) : boolean;
    begin
      PosIn :=  (x>=Zn.x) and (x<=Zn.x+Zn.lg-1) and
                (y>=Zn.y) and (y<=Zn.y+Zn.ht-1);
    end;
    procedure EvolZn(plein,vide : Zn_Rec);
    var l,c : byte;
    begin
      with plein do
        for l:= y to y+ht-1 do
          for c:= x to x+lg-1 do
            if not(PosIn(c,l,vide)) then AffDataShowCadre(c,l);
      with vide do
        for l:= y to y+ht-1 do
          for c:= x to x+lg-1 do
            if not(PosIn(c,l,plein)) then AffDataShow(c,l);
    end;
  var EndBoucle : boolean;
      ancien : Zn_Rec;
      OrgX,OrgY : Byte;

   Procedure Abandon;
   Begin
    EndBoucle := true;
    ZnGet := false;
   End;

  begin
    EndBoucle := False;
    OrgX := CurX;
    OrgY := CurY;
    courant.x := CurX;
    courant.y := CurY;
    courant.lg := 1;
    courant.ht := 1;
    ancien := courant;
    AffDataShowCadre(CurX,CurY);
(*
    ZnEnForm(courant);
*)
    CoordZn(courant,ZnCtrl.x+1,ZnCtrl.y+1);
    repeat
      MouseStatus;
      If Not(Funct) And (Key=#27) Then Abandon
      Else
       Begin
        if (MouseC>19+PXhaut) and (MouseC<21+PXbas) and
           (MouseL>=PYhaut) and (MouseL<=PYbas) then
          begin
            CurX := MouseC-20;
            CurY := MouseL;
          end
        else
          begin
            if MouseC<=19+PXhaut then CurX := PXhaut
            else
              if MouseC>=21+PXbas then CurX := PXbas
              else CurX := MouseC-20;
            if MouseL<PYhaut then CurY := PYhaut
            else
              if MouseL>PYbas then CurY := PYbas
              else CurY := MouseL;
            ForceMouseTo((CurX+20)*8,(CurY)*8);
          end;
        { redif cadre ou non }
        if (CurX<>ExCurX) or (CurY<>ExCurY) then
          begin { redif OUI }
            if CurX<OrgX then courant.x := CurX
            else courant.x := OrgX;
            if CurY<OrgY then courant.y := CurY
            else courant.y := OrgY;
            courant.lg := abs(OrgX-CurX)+1;
            courant.ht := abs(OrgY-CurY)+1;
            EvolZn(courant,ancien);
            ancien := courant;
            CoordZn(courant,ZnCtrl.x+1,ZnCtrl.y+1);
            CurXY(CurX+21-1,CurY+1-1);
            CurSitu;
          end;
        if ButtonR then
          begin
            repeat MouseStatus until not(ButtonR);
            Abandon;
          end
        else
          if ButtonL then
            begin
              repeat MouseStatus until not(ButtonL);
              EndBoucle := true;
              ZnGet := true;
            end;
        InterRefresh;
       End;
    until EndBoucle;
  end;

var EndBoucle : boolean;
    ZnCadre : Zn_Rec;
    NumFile : byte;
    OrgNumPage : byte;

const Zn : Zn_Rec = (x:20; y:1; lg:40; ht:24);
begin { CadrageChoix }
  NewMenu('Zonage',PointNothing,0);
  ChsFldStd;
  WrtScr(CentreString(' Attente de',18,32),61,5,CMiNet);
  WrtScr(CentreString(' dfinition',18,32),61,6,CMiNet);
  WrtScr(CentreString('d''une zone.',18,32),61,7,CMiNet);

  if (PXhaut<>0) or (PXbas<>ScreenLong-1) or (PYhaut<>1) or (PYbas<>ScreenHigh-1) then
    begin
      MakeTrait(22,1,2);
      WrtScr(CentreString('Suppr.espace compo',18,32),61,23,CDisp);
      ChsFld(39);
    end;

  EndBoucle := false;
  repeat
    if Interaction then
      begin
        if key<>#0 then
         Begin
          If Not(Funct) And (Key=#27) Then EndBoucle := TRUE
          Else TheBeep;
         End
        Else
         if not(StdChoix) then
          case inter.SelectField of
            19 : EndBoucle := true;
            39 : begin
                   PXhaut := 0; PXbas := ScreenLong-1;
                   PYhaut := 1; PYbas := ScreenHigh-1;
                   ResetAffCompo := TRUE;
                   EndBoucle := TRUE;
                 end;
          end;
      end
    else
     If Not(Funct) And (Key=#27) Then EndBoucle := TRUE
     Else
      if ButtonR then EndBoucle := true
      else
        if ButtonL then
          begin
            NumFile := SaveZn(Zn);
            OrgNumPage := NumPage;
            repeat
              MouseStatus;
            until not(ButtonL);
            PushZn(ZnCtrl);
            CCdrZn(ZnCtrl,CDRNORM,CSep);
            WrtScr(MemTexte(NumPage),ZnCtrl.x+ZnCtrl.lg-7,ZnCtrl.y,CNet);
            if ZnGet(ZnCadre) then
              begin
              (*
                NumFileTemp := SaveZn(ZnTemp);
                *)
                NumFileCoord := SaveZn(ZnCtrl);
                (*
                RstZnTo(NumFileCoord,ZnTemp.x,ZnTemp.y);
                *)
                EndBoucle := CadrageAction(ZnCadre);
                if not(EndBoucle) and (OrgNumPage=NumPage) then RstZn(NumFile);
                CloseZn(NumFileCoord);
              (*
                RstZn(NumFileTemp);

                CloseZn(NumFileTemp);
              *)
              end
            else RstZn(NumFile);
            popZn;
            CloseZn(NumFile);
          end;
  until EndBoucle;
  EndNewMenu;
end;

function StdKeyChoix : boolean;
begin
  StdKeyChoix := PanelCMD or GlobalKey;
end;



Function MyFixeField1( Var field1 : fields_map;  Data : Pointer ) : Boolean; Far;
Const FondX  = 5;
      FondY  = 0;
Var i, j : Byte;
    cx, cy : Byte;
Begin
 For i := 0 To 5 Do
  For j := 0 To 15 Do
   Begin
    cx := FondX+3+(i*7);
    cy := FondY+2+1+j;
    If (MouseC>=cx) And (MouseC<cx+6) And
       (MouseL>=cy) And (MouseL<cy+1) Then
     Begin
      With field1 Do
       Begin
        X    := cx;
        Y    := cy;
        Long := 6;
        Haut := 1;
        Vis  := TRUE;
        NoR  := TRUE;
       End;
      MyFixeField1 := TRUE;
      Byte(Data^) := (i*16+j);   { "n" champ select }
      Exit;
     End;
   End;

 If (MouseC>=FondX+47+1) And (MouseC<FondX+47+1+8) And
    (MouseL>=FondY+2+1) And (MouseL<FondY+2+1+10) Then
  Begin
   With field1 Do
    Begin
     X    := MouseC;
     Y    := MouseL;
     Long := 1;
     Haut := 1;
     Vis  := TRUE;
     NoR  := TRUE;
    End;
   MyFixeField1 := TRUE;
   Byte(Data^) := 128+( (MouseC-(FondX+47+1))+((MouseL-(FondY+2+1))*8) );
   Exit;
  End;

 MyFixeField1 := FALSE;
End;


Procedure EditDRCS;
Const FondX  = 5;
      FondY  = 0;
      ZnFond : Zn_Rec = (x:FondX; y:FondY; lg:70; ht:25);
      ZnJeu  : Zn_Rec = (x:FondX+2; y:FondY+2; lg:43; ht:18);
      ZnGMat : Zn_Rec = (x:FondX+47; y:FondY+2; lg:10; ht:12);
      ZnSMat : Zn_Rec = (x:FondX+58; y:FondY+2; lg:10; ht:7);
      ZnSSMat: Zn_Rec = (x:FondX+58; y:FondY+2+8; lg:10; ht:7);

 Procedure AfficheDecors;
 Var i, j : Byte;
 Begin
  ClrZn(ZnFond,CWind);
  CCdrZn(ZnFond,CDRNORM,CCadre);
  ClrZn(ZnJeu,TNet);
  CCdrZn(ZnJeu,CDRNORM,CSep);
  For i := 0 To 4 Do
   Begin
    WrtDt(Byte(''),FondX+7+2+i*7,FondY+2,CSep);
    WrtDt(Byte(''),FondX+7+2+i*7,FondY+2+16+1,CSep);
   End;

  For i := 0 To 4 Do
   For j := 0 To 15 Do
    Begin
     WrtDt(Byte(''),FondX+7+2+i*7,FondY+2+1+j,CCadre);
    End;

  For i := 0 To 5 Do
   For j := 0 To 15 Do
    Begin
     WrtScr(Hexa(i*16+j+$20),FondX+3+(i*7),FondY+2+1+j,TNet);
    End;

  ClrZn(ZnGMat,TNet);
  CCdrZn(ZnGMat,CDRNORM,CSep);
  WrtDt(Byte('/'),FondX+47-1,FondY+2+5,CWind);
  WrtDt(Byte('\'),FondX+47-1,FondY+2+5+1,CWind);
  WrtDt(Byte('\'),FondX+47+10,FondY+2+5,CWind);
  WrtDt(Byte('/'),FondX+47+10,FondY+2+5+1,CWind);
  WrtDt(Byte('/'),FondX+47+4,FondY+1,CWind);
  WrtDt(Byte('\'),FondX+47+4+1,FondY+1,CWind);
  WrtDt(Byte('\'),FondX+47+4,FondY+2+12,CWind);
  WrtDt(Byte('/'),FondX+47+4+1,FondY+2+12,CWind);

  ClrZn(ZnSMat,TNet);
  CCdrZn(ZnSMat,CDRNORM,CSep);
  ClrZn(ZnSSMat,TNet);
  CCdrZn(ZnSSMat,CDRNORM,CSep);

  WrtScr('  Vide  ',FondX+47+1,FondY+16,CWind);
  WrtScr('Inverse ',FondX+47+1,FondY+16+2,CWind);
  WrtScr(' Annule ',FondX+47+1,FondY+16+4,CWind);
  WrtScr(' Exclu  ',FondX+47+12,FondY+16+2,CWind);
  WrtScr(' Inclu  ',FondX+47+12,FondY+16+4,CWind);

  WrtScr('Copie',FondX+3,FondY+20,CWind);
  WrtScr('Echange',FondX+3+8,FondY+20,CWind);

  WrtScr(' ABANDON ',FondX+1,FondY+23,CChoix);
  WrtScr(' Initialiser ',FondX+15+4,FondY+23,CChoix);
  WrtScr(' Test ',FondX+36+8,FondY+23,CChoix);
  WrtScr('   OK   ',FondX+58-9+12,FondY+23,CChoix);

 End;

 Procedure ChsEditFld;
 Var i : Byte;
 Begin
  ChsFld(1);
  For i := 132 To 135 Do ChsFld(i);
 End;

Var EndB : Boolean;
    PY   : Byte;
    Ex   : FixeField1Proc;
    ExDt : Pointer;
    SFld : Byte;
Begin
 EmpileFld;

 PushZn(ZnFond);

 ExDt := DataField1;
 Ex := FixeField1;

 DataField1 := @SFld;
 FixeField1 := MyFixeField1;

 PY := PYHaut;
 PYHaut := ScreenHigh;

 ChsEditFld;

 AfficheDecors;

 EndB := FALSE;

 Repeat
  If Interaction Then
   If Key=#0 Then
    Begin
     Case Inter.SelectField Of
      132 : Begin   { Abandon }
             EndB := TRUE;
            End;
      135 : Begin
             EndB := TRUE;   { Ok }
            End;
     Else NoFieldLand;
     End;
    End
   Else
    If Not(Funct) Then
     Begin
      Case UpCase(Key) Of
       #27 : EndB := TRUE;
      Else TheBeep;
      End;
     End
    Else TheBeep;

 Until EndB;

 PYHaut := PY;

 DataField1 := ExDt;
 FixeField1 := Ex;

 PopZn;

 DepileFld;
End;
